## numpy 1.17.4

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# PYVER needs to be major.minor, just "3" doesn't work - it will result in
# issues with the amendments to PYTHONPATH and install paths (see DIST_VARS).

# Use explicit "version_info" indexing since make cannot handle colon characters, and
# evaluate it now to allow easier debugging when printing the variable

PYVER:=$(shell python3 -c 'from sys import version_info as v; print("{0}.{1}".format(v[0], v[1]))')
PYTHON = python$(PYVER)

# You can set these variables from the command line.
SPHINXOPTS    ?=
SPHINXBUILD   ?= LANG=C sphinx-build
PAPER         ?=

FILES=

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -WT --keep-going -d build/doctrees $(PAPEROPT_$(PAPER)) \
  $(SPHINXOPTS) source

.PHONY: help clean html web pickle htmlhelp latex changes linkcheck \
        dist dist-build gitwash-update version-check html-build latex-build

#------------------------------------------------------------------------------

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  html-scipyorg  to make standalone HTML files with scipy.org theming"
	@echo "  pickle    to make pickle files (usable by e.g. sphinx-web)"
	@echo "  htmlhelp  to make HTML files and a HTML help project"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  changes   to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  dist PYVER=... to make a distribution-ready tree"
	@echo "  gitwash-update GITWASH=path/to/gitwash  update gitwash developer docs"
	@echo "  upload USERNAME=... RELEASE=... to upload built docs to docs.scipy.org"

clean:
	-rm -rf build/* 
	find . -name generated -type d -prune -exec rm -rf "{}" ";"

gitwash-update:
	rm -rf source/dev/gitwash
	install -d source/dev/gitwash
	python $(GITWASH)/gitwash_dumper.py source/dev NumPy \
	    --repo-name=numpy \
	    --github-user=numpy
	cat source/dev/gitwash_links.txt >> source/dev/gitwash/git_links.inc

#------------------------------------------------------------------------------
# Automated generation of all documents
#------------------------------------------------------------------------------

# Build the current numpy version, and extract docs from it.
# We have to be careful of some issues:
# 
# - Everything must be done using the same Python version
# - We must use eggs (otherwise they might override PYTHONPATH on import).
# - Different versions of easy_install install to different directories (!)
#


INSTALL_DIR = $(CURDIR)/build/inst-dist
INSTALL_PPH = $(INSTALL_DIR)/lib/python$(PYVER)/site-packages:$(INSTALL_DIR)/local/lib/python$(PYVER)/site-packages:$(INSTALL_DIR)/lib/python$(PYVER)/dist-packages:$(INSTALL_DIR)/local/lib/python$(PYVER)/dist-packages
UPLOAD_DIR=/srv/docs_scipy_org/doc/numpy-$(RELEASE)

DIST_VARS=SPHINXBUILD="LANG=C PYTHONPATH=$(INSTALL_PPH) python$(PYVER) `which sphinx-build`" PYTHON="PYTHONPATH=$(INSTALL_PPH) python$(PYVER)" 

NUMPYVER:=$(shell $(PYTHON) -c "import numpy; print(numpy.version.git_revision[:10])" 2>/dev/null)
GITVER ?= $(shell cd ..; $(PYTHON) -c "from setup import git_version; \
				print(git_version()[:10])")

version-check:
ifeq "$(GITVER)" "Unknown"
	# @echo sdist build with unlabeled sources
else ifeq ("", "$(NUMPYVER)")
	@echo numpy not found, cannot build documentation without successful \"import numpy\"
	@exit 1
else ifneq ($(NUMPYVER),$(GITVER))
	@echo installed numpy $(NUMPYVER) != current repo git version \'$(GITVER)\'
	@echo use '"make dist"' or '"GITVER=$(NUMPYVER) make $(MAKECMDGOALS) ..."'
	@exit 1
else
	# for testing
	# @echo installed numpy $(NUMPYVER) matches git version $(GITVER); exit 1
endif


dist:
	make $(DIST_VARS) real-dist

real-dist: dist-build html-build html-scipyorg
	test -d build/latex || make latex-build
	make -C build/latex all-pdf
	-rm -rf build/dist
	cp -r build/html-scipyorg build/dist
	cd build/html && zip -9r ../dist/numpy-html.zip .
	cp build/latex/numpy-ref.pdf build/dist
	cp build/latex/numpy-user.pdf build/dist
	cd build/dist && tar czf ../dist.tar.gz *
	chmod ug=rwX,o=rX -R build/dist
	find build/dist -type d -print0 | xargs -0r chmod g+s

dist-build:
	rm -f ../dist/*.egg
	cd .. && $(PYTHON) setup.py bdist_egg
	install -d $(subst :, ,$(INSTALL_PPH))
	$(PYTHON) `which easy_install` --prefix=$(INSTALL_DIR) ../dist/*.egg

upload:
	# SSH must be correctly configured for this to work.
	# Assumes that ``make dist`` was already run
	# Example usage: ``make upload USERNAME=rgommers RELEASE=1.10.1``
	ssh $(USERNAME)@docs.scipy.org mkdir $(UPLOAD_DIR)
	scp build/dist.tar.gz $(USERNAME)@docs.scipy.org:$(UPLOAD_DIR)
	ssh $(USERNAME)@docs.scipy.org tar xvC $(UPLOAD_DIR) \
	    -zf $(UPLOAD_DIR)/dist.tar.gz
	ssh $(USERNAME)@docs.scipy.org mv $(UPLOAD_DIR)/numpy-ref.pdf \
	    $(UPLOAD_DIR)/numpy-ref-$(RELEASE).pdf
	ssh $(USERNAME)@docs.scipy.org mv $(UPLOAD_DIR)/numpy-user.pdf \
	    $(UPLOAD_DIR)/numpy-user-$(RELEASE).pdf
	ssh $(USERNAME)@docs.scipy.org mv $(UPLOAD_DIR)/numpy-html.zip \
	    $(UPLOAD_DIR)/numpy-html-$(RELEASE).zip
	ssh $(USERNAME)@docs.scipy.org rm $(UPLOAD_DIR)/dist.tar.gz
	ssh $(USERNAME)@docs.scipy.org ln -snf numpy-$(RELEASE) /srv/docs_scipy_org/doc/numpy

#------------------------------------------------------------------------------
# Basic Sphinx generation rules for different formats
#------------------------------------------------------------------------------

generate: build/generate-stamp
build/generate-stamp: $(wildcard source/reference/*.rst)
	mkdir -p build
	touch build/generate-stamp

html: version-check html-build
html-build: generate
	mkdir -p build/html build/doctrees
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) build/html $(FILES)
	$(PYTHON) postprocess.py html build/html/*.html
	@echo
	@echo "Build finished. The HTML pages are in build/html."

html-scipyorg:
	mkdir -p build/html build/doctrees
	$(SPHINXBUILD) -t scipyorg -b html $(ALLSPHINXOPTS) build/html-scipyorg $(FILES)
	@echo
	@echo "Build finished. The HTML pages are in build/html."

pickle: generate version-check
	mkdir -p build/pickle build/doctrees
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) build/pickle $(FILES)
	@echo
	@echo "Build finished; now you can process the pickle files or run"
	@echo "  sphinx-web build/pickle"
	@echo "to start the sphinx-web server."

web: pickle

htmlhelp: generate version-check
	mkdir -p build/htmlhelp build/doctrees
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) build/htmlhelp $(FILES)
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in build/htmlhelp."

htmlhelp-build: htmlhelp build/htmlhelp/numpy.chm
%.chm: %.hhp
	-hhc.exe $^

qthelp: generate version-check
	mkdir -p build/qthelp build/doctrees
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) build/qthelp $(FILES)

latex: version-check latex-build
latex-build: generate
	mkdir -p build/latex build/doctrees
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) build/latex $(FILES)
	$(PYTHON) postprocess.py tex build/latex/*.tex
	perl -pi -e 's/\t(latex.*|pdflatex) (.*)/\t-$$1 -interaction batchmode $$2/' build/latex/Makefile
	@echo
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

coverage: build version-check
	mkdir -p build/coverage build/doctrees
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) build/coverage $(FILES)
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

changes: generate version-check
	mkdir -p build/changes build/doctrees
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) build/changes $(FILES)
	@echo
	@echo "The overview file is in build/changes."

linkcheck: generate version-check
	mkdir -p build/linkcheck build/doctrees
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) build/linkcheck $(FILES)
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in build/linkcheck/output.txt."

texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) build/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in build/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) build/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C build/texinfo info
	@echo "makeinfo finished; the Info files are in build/texinfo."

=== tools/ci/appveyor/requirements.txt ===
cython
nose
pytest-timeout
pytest-xdist
pytest-env
pytest-faulthandler

=== debian/changelog ===
numpy (1:1.17.4-5ubuntu3) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 10:44:35 +0100

numpy (1:1.17.4-5ubuntu2) focal; urgency=medium

  * Move versions3.helper to python3

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 07 Jan 2020 18:29:58 +0100

numpy (1:1.17.4-5) unstable; urgency=medium

  * debian/rules
    - edit entry_points.txt only if it's present, fixing a FTBFS for arch:all;
      Closes: #945263

 -- Sandro Tosi <morph@debian.org>  Sun, 22 Dec 2019 01:50:13 -0500

numpy (1:1.17.4-4) unstable; urgency=medium

  * debian/rules
    - add an f2py entry_point for all supported py3k versions; Closes: #945263
  * debian/patches/use_local_object.inv_files.patch
    - update SciPy object.inv location

 -- Sandro Tosi <morph@debian.org>  Wed, 11 Dec 2019 12:57:27 -0500

numpy (1:1.17.4-3) unstable; urgency=medium

  * debian/tests/control
    - add python3-distutils to the `distutils` test depends

 -- Sandro Tosi <morph@debian.org>  Sun, 17 Nov 2019 19:21:07 -0500

numpy (1:1.17.4-2) unstable; urgency=medium

  * debian/tests/{atlas,openblas}
    - use the `python3` script in autotests

 -- Sandro Tosi <morph@debian.org>  Sat, 16 Nov 2019 23:58:08 -0500

numpy (1:1.17.4-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * Bump Standards-Version to 4.4.1.
  * d/control: Fix wrong Vcs-*.

  [ Sandro Tosi ]
  * New upstream release
  * debian/patches/PR14769.patch
    - fix integer size confusion in handling array's ndmin on s390x

 -- Sandro Tosi <morph@debian.org>  Tue, 12 Nov 2019 10:30:17 -0500

numpy (1:1.17.2-1) experimental; urgency=medium

  * New upstream release
  * Rename source package to numpy, to track py3k-only upstream source
  * debian/watch
    - track the latest release
  * debian/control
    - drop python2 packages
    - use cython3 >= 0.29.2
    - add ipython, scipy, dvisvgm, texlive-latex-base/extra to b-d, needed to
      build doc
    - remove all Breaks/Repleaces from -dbg package
  * debian/tests
    - autopkgtests: only test py3k
  * debian/dh_numpy*
    - keep only py3k dh_numpy (+ helpers)
  * debian/rules
    - build only py3k packages
    - dont regenerate generate_mtrand_c.py, removed upstream
    - use pybuild
    - let tests be run during install, not via dh sequencer
  * debian/copyright
    - update to upstream new code
  * Use objects.inv from python3/scipy/maptlotlib -doc packages

 -- Sandro Tosi <morph@debian.org>  Sat, 21 Sep 2019 16:09:25 -0400

python-numpy (1:1.16.5-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * Use debhelper-compat instead of debian/compat.
  * Bump Standards-Version to 4.4.0.

  [ Drew Parsons ]
  * move python3-matplotlib to Build-Depends-Indep. Build docs under
    override_dh_auto_build-indep. Thanks Jason Duerstock.
    Closes: #929975

  [ Sandro Tosi ]
  * New upstream release; Closes: #933056, #931541
  * debian/watch
    - only search for 1.16.x releases, the only ones supporting python2
  * debian/copyright
    - document numpy/linalg/lapack_lite/ copyright and license

 -- Sandro Tosi <morph@debian.org>  Sat, 07 Sep 2019 17:33:43 -0400

python-numpy (1:1.16.2-1) unstable; urgency=medium

  * New upstream release

 -- Sandro Tosi <morph@debian.org>  Sat, 02 Mar 2019 11:30:12 -0500

python-numpy (1:1.16.1-1) unstable; urgency=medium

  * New upstream release

 -- Sandro Tosi <morph@debian.org>  Thu, 31 Jan 2019 22:21:17 -0500

python-numpy (1:1.16.0-1) unstable; urgency=medium

  * New upstream release

 -- Sandro Tosi <morph@debian.org>  Thu, 17 Jan 2019 22:49:04 -0500

python-numpy (1:1.16.0~rc2-2) unstable; urgency=medium

  * Team upload.

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces.

  [ Emilio Pozuelo Monfort ]
  * Add more breaks for older versions of packages not compatible with
    Numpy 1.16.
  * Fix breaks on python-astropy. Closes: #918544.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Fri, 11 Jan 2019 14:51:15 +0100

python-numpy (1:1.16.0~rc2-1) unstable; urgency=medium

  * New upstream release candidate
  * debian/control
    - restore b-d on libblas-dev and liblapack-dev, instead of
      libatlas-base-dev; Closes: #913567
    - Add Breaks for packages not compatible with 1.16; Closes: #918399
  * debian/copyright
    - extend packaging copyright years
    - update upstream copyright years
  * debian/patches/0007-fix-test_various_alignments.patch
    - drop, applied upstream

 -- Sandro Tosi <morph@debian.org>  Sat, 05 Jan 2019 19:54:44 -0500

python-numpy (1:1.16.0~rc1-3) unstable; urgency=medium

  * debian/control
    - add pkg_resources to Depends, needed by f2py; Closes: #917878

 -- Sandro Tosi <morph@debian.org>  Mon, 31 Dec 2018 14:39:01 -0500

python-numpy (1:1.16.0~rc1-2) unstable; urgency=medium

  * debian/patches/0007-fix-test_various_alignments.patch
    - fix FTBFS on i386 archs due to tests suite being Aborted
  * debian/control
    - bump Standards-Version to 4.3.0 (no changes needed)

 -- Sandro Tosi <morph@debian.org>  Wed, 26 Dec 2018 11:37:59 -0500

python-numpy (1:1.16.0~rc1-1) unstable; urgency=medium

  * New upstream release candidate
  * debian/copyright
    - update upstream copyright years
  * debian/patch
    - refresh, drop
  * debian/rules
    - remove override_dh_python2, no longer needed
  * debian/versions
    - update ABI/API versions
  * debian/control
    - drop explicit b-d on python3.6-dev; Closes: #916821

 -- Sandro Tosi <morph@debian.org>  Mon, 24 Dec 2018 15:26:14 -0500

python-numpy (1:1.15.4-2) unstable; urgency=medium

  * debian/patches/python3-soabi.patch
    - fix skip syntax
  * debian/tests/control
    - switch from nose to pytest

 -- Sandro Tosi <morph@debian.org>  Thu, 22 Nov 2018 18:02:32 -0500

python-numpy (1:1.15.4-1) unstable; urgency=medium

  * New upstream release
  * debian/control
    - switch from nose to pytest
    - b-d on libatlas-base-dev
    - bump Standards-Version to 4.2.1 (no changes needed)
  * debian/copyright


=== debian/control ===
Source: numpy
Section: python
Priority: optional
Maintainer: Sandro Tosi <morph@debian.org>
Uploaders: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
Build-Depends-Indep: python3-matplotlib
Build-Depends: cython3 (>= 0.29.2),
               debhelper-compat (= 11),
               dh-python,
               dvisvgm,
               gfortran (>= 4:4.2),
               libblas-dev [!arm !m68k],
               liblapack-dev [!arm !m68k],
               python3-all-dbg,
               python3-all-dev,
               python3-doc,
               python3-ipython,
               python-matplotlib-doc,
               python3-pytest,
               python-scipy-doc,
               python3-scipy,
               python3-setuptools,
               python3-sphinx,
               python3-tz,
               texlive-latex-base,
               texlive-latex-extra,
Standards-Version: 4.4.1
Vcs-Git: https://salsa.debian.org/python-team/modules/numpy.git
Vcs-Browser: https://salsa.debian.org/python-team/modules/numpy
Homepage: http://www.numpy.org/

Package: python3-numpy
Architecture: any
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}, python3-pkg-resources
Suggests: gcc (>= 4:4.6.1-5),
          gfortran,
          python-numpy-doc,
          python3-dev,
          python3-pytest,
          python3-numpy-dbg
Provides: python3-f2py,
          python3-numpy-dev,
          ${numpy3:Provides},
          ${python3:Provides}
Breaks: python3-aplpy (<< 2.0~rc2-1),
        python3-astropy (<< 3.1-1),
        python3-ccdproc (<< 1.3.0-5),
        python3-dask (<< 1.0.0+dfsg-2),
        python3-skimage (<< 0.14.1-3),
        python3-tables (<< 3.4.4-2),
        python3-theano (<< 1.0.3+dfsg-1),
Description: Fast array facility to the Python 3 language
 Numpy contains a powerful N-dimensional array object, sophisticated
 (broadcasting) functions, tools for integrating C/C++ and Fortran
 code, and useful linear algebra, Fourier transform, and random number
 capabilities.
 .
 Numpy replaces the python-numeric and python-numarray modules which are
 now deprecated and shouldn't be used except to support older
 software.
 .
 This package contains Numpy for Python 3.

Package: python3-numpy-dbg
Section: debug
Architecture: any
Multi-Arch: same
Depends: python3-dbg,
         python3-numpy (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Fast array facility to the Python 3 language (debug extension)
 Numpy contains a powerful N-dimensional array object, sophisticated
 (broadcasting) functions, tools for integrating C/C++ and Fortran
 code, and useful linear algebra, Fourier transform, and random number
 capabilities.
 .
 Numpy replaces the python-numeric and python-numarray modules which
 are now deprecated and shouldn't be used except to support older
 software.
 .
 This package contains the extension built for the Python 3 debug interpreter.

Package: python-numpy-doc
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Section: doc
Architecture: all
Multi-Arch: foreign
Description: NumPy documentation
 Numpy contains a powerful N-dimensional array object, sophisticated
 (broadcasting) functions, tools for integrating C/C++ and Fortran
 code, and useful linear algebra, Fourier transform, and random number
 capabilities.
 .
 Numpy replaces the python-numeric and python-numarray modules which
 are now deprecated and shouldn't be used except to support older
 software.
 .
 This package contains documentation for Numpy and f2py.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

PY3VERS=$(shell py3versions -vr)
PY3DEF=$(shell py3versions -dv)
PY3LIBPATH := $(shell python3 -c "from distutils.command.build import build ; from distutils.core import Distribution ; b = build(Distribution()) ; b.finalize_options() ; print (b.build_platlib)")

# Look at #634012 to understand why is needed and what will happen if we set
# compat to 9
unexport LDFLAGS
export ATLAS=None

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_build-arch:
	dh_auto_build
	set -e; for v in $(PY3VERS); do \
		python$$v setup.py build; \
		python$$v-dbg setup.py build; \
	done

override_dh_auto_build-indep: override_dh_auto_build-arch
	# build doc only for default python version
	(export MPLCONFIGDIR=. ; make -C doc html PYTHON=python3 PYTHONPATH=../$(PY3LIBPATH))

override_dh_auto_clean:
	rm -rf build/
	rm -rf `find -name build -type d`
	rm -rf `find . -name "*.pyc" -type f`
	rm -rf doc/fontList.cache numpy/f2py/docs/usersguide/index.html
	rm -rf doc/source/reference/generated
	# cython generated
	rm -f numpy/random/mtrand/mtrand.c

#override_dh_installman:
#	dh_installman -ppython3-numpy doc/f2py/f2py.1
#	-mv debian/python3-numpy/usr/share/man/man1/f2py.1 \
#	  debian/python3-numpy/usr/share/man/man1/f2py3.1
#	# link manpage for versioned and dbg incarnations of f2py
#	set -e; for v in $(PY3VERS); do \
#		dh_link -ppython3-numpy /usr/share/man/man1/f2py3.1.gz /usr/share/man/man1/f2py$$v.1.gz; \
#		dh_link -ppython3-numpy-dbg /usr/share/man/man1/f2py3.1.gz /usr/share/man/man1/f2py$$v-dbg.1.gz; \
#	done
#	dh_link -ppython3-numpy-dbg /usr/share/man/man1/f2py3.1.gz /usr/share/man/man1/f2py3-dbg.1.gz;

override_dh_python3:
	dh_python3

	ENTRYPOINT=non-existant
	# tweak the entry_points list to include all supported versions
	if [ -f $(CURDIR)/debian/python3-numpy/usr/lib/python3/dist-packages/numpy-*.egg-info/entry_points.txt ] ; then \
		ENTRYPOINT=$(shell ls $(CURDIR)/debian/python3-numpy/usr/lib/python3/dist-packages/numpy-*.egg-info/entry_points.txt) ; \
		for v in $(PY3VERS); do \
			if ! grep $$v $$ENTRYPOINT; \
			then \
				echo "f2py$$v = numpy.f2py.f2py2e:main" >> $$ENTRYPOINT ; \
			fi; \
		done \
	fi

override_dh_install:
	# add shebang information to f2py script
	set -e; for v in $(PY3VERS); do \
		sed -i "1s,#!.*python[^ ]*\(.*\),#!/usr/bin/python$$v," debian/tmp/usr/bin/f2py$$v; \
		cp -a debian/tmp/usr/bin/f2py$$v debian/tmp/usr/bin/f2py$$v-dbg ; \
		sed -i "1s,#!.*python[^ ]*\(.*\),#!/usr/bin/python$$v-dbg," debian/tmp/usr/bin/f2py$$v-dbg; \
	done
	cp -a debian/tmp/usr/bin/f2py$(PY3DEF) debian/tmp/usr/bin/f2py3
	sed -i "1s,#!.*python[^ ]*\(.*\),#!/usr/bin/python3," debian/tmp/usr/bin/f2py3
	cp -a debian/tmp/usr/bin/f2py$(PY3DEF)-dbg debian/tmp/usr/bin/f2py3-dbg
	sed -i "1s,#!.*python[^ ]*\(.*\),#!/usr/bin/python3-dbg," debian/tmp/usr/bin/f2py3-dbg

	dh_install

	# create symlinks for .h files
	set -e; for i in $(PY3VERS); do \
	ABITAG=`python$$i -c "import sys; print(sys.abiflags)"`; \
	[ -d $(CURDIR)/debian/python3-numpy/usr/include/python$$i$$ABITAG ] || \
		mkdir -p $(CURDIR)/debian/python3-numpy/usr/include/python$$i$$ABITAG; \
		dh_link -ppython3-numpy usr/lib/python3/dist-packages/numpy/core/include/numpy usr/include/python$$i$$ABITAG/numpy; \
	done
	set -e; for i in $(PY3VERS); do \
	ABITAG=`python$$i-dbg -c "import sys; print(sys.abiflags)"`; \
	[ -d $(CURDIR)/debian/python3-numpy-dbg/usr/include/python$${i}$$ABITAG ] || \
		mkdir -p $(CURDIR)/debian/python3-numpy-dbg/usr/include/python$${i}$$ABITAG; \
		dh_link -ppython3-numpy-dbg usr/lib/python3/dist-packages/numpy/core/include/numpy/ usr/include/python$${i}$$ABITAG/numpy; \
	done

	# share -dbg and normal package doc dirs
	rm -rf debian/python3-numpy-dbg/usr/share/doc/python3-numpy-dbg
	dh_link -ppython3-numpy-dbg usr/share/doc/python3-numpy usr/share/doc/python3-numpy-dbg

override_dh_gencontrol:
	python3 debian/versions3.helper >> debian/python3-numpy.substvars
	dh_gencontrol

override_dh_compress:
	dh_compress -X.js -Xobjects.inv -X.txt

override_dh_strip:
ifeq (,$(filter nostrip,$(DEB_BUILD_OPTIONS)))
	dh_strip -ppython3-numpy --dbg-package=python3-numpy-dbg
	# dh_strip seemingly doesn't catch the PEP 3149-style debug names
	rm debian/python3-numpy/usr/lib/python3*/*-packages/*/*/*.cpython-3?d*.so
endif


override_dh_installdocs-indep:
	dh_installdocs -i
	dh_sphinxdoc -i

override_dh_auto_test:
	echo "pass"

override_dh_auto_install:
	dh_auto_install

	# Install for Python 3
	set -e; for v in $(PY3VERS); do \
		python$$v setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb; \
		python$$v-dbg setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb; \
	done

	# yes, we need to run tests after install
	# The reason is that numpy tries hard to not let you run it from the
	# source directory, so we need to mess with the import order so to
	# select the code in the installation path
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	set -e; for v in $(PY3VERS) ; do \
		cd debian ; \
		echo "-- running tests for "$$v" plain --" ; \
		python$$v -c "import sys ; sys.path.insert(0, './tmp/usr/lib/python3/dist-packages/') ; import numpy; numpy.test(verbose=5)" ; \
		echo "-- running tests for "$$v" debug --" ; \
		python$$v-dbg -c "import sys ; sys.path.insert(0, './tmp/usr/lib/python3/dist-packages/') ; import numpy; numpy.test(verbose=5)" ; \
		cd .. ; \
	done
endif

## numpy 1.18.4

=== debian/changelog ===
numpy (1:1.18.4-1ubuntu1) groovy; urgency=medium

  * Removed --std=c99 extra compiler flags causing floating point
    issues during python-meshio autopkgtest on s390x

 -- Matthieu Clemenceau <matthieu.clemenceau@canonical.com>  Thu, 28 May 2020 16:31:25 -0500

numpy (1:1.18.4-1) unstable; urgency=medium

  * New upstream release

 -- Sandro Tosi <morph@debian.org>  Wed, 06 May 2020 19:26:24 -0400

numpy (1:1.18.3-1) unstable; urgency=medium

  * New upstream release
  * debian/control
    - bump Standards-Version to 4.5.0 (no changes needed)

 -- Sandro Tosi <morph@debian.org>  Sun, 19 Apr 2020 21:36:17 -0400

numpy (1:1.18.2-2) unstable; urgency=medium

  * debian/patches/debian_skip_tests.patch
    - skip test_compile*, as we cant realiably compile from within numpy module
      location (sadly numpy.test() extra_argv didnt work)

 -- Sandro Tosi <morph@debian.org>  Sat, 18 Apr 2020 02:06:44 -0400

numpy (1:1.18.2-1) unstable; urgency=medium

  [ Laurent Bigonville ]
  * Team upload.
  * Port debian/versions3.helper to python3; Closes: #948354, #956527
  * debian/control: Mark several BD with <!nocheck> to break dependency cycle
    (Closes: #946607)
  * debian/control: Move the packages needed to generate the doc package to BDI
  * debian/control: Mark the -doc package and its BD with <!nodoc>
  * debian/control: Make the python3-numpy package provide dh-sequence-numpy3
    (Closes: #950953)

  [ Sandro Tosi ]
  * New upstream release
  * debian/python3-numpy.docs
    - install some additional documentation
  * debian/control
    - require sphinx 2+
  * Refresh & drop patches as per new upstream code
  * debian/copyright
    - extend packaging copyright years

 -- Sandro Tosi <morph@debian.org>  Thu, 16 Apr 2020 01:11:06 -0400

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,18 @@
 Source: numpy
 Section: python
 Priority: optional
-Maintainer: Sandro Tosi <morph@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Sandro Tosi <morph@debian.org>
 Uploaders: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
-Build-Depends-Indep: python3-matplotlib
+Build-Depends-Indep: python-matplotlib-doc <!nodoc>,
+                     python-scipy-doc <!nodoc>,
+                     python3-doc <!nodoc>,
+                     python3-ipython <!nodoc>,
+                     python3-matplotlib <!nodoc>,
+                     python3-scipy <!nodoc>,
+                     python3-sphinx (>= 2) <!nodoc>,
+                     texlive-latex-base <!nodoc>,
+                     texlive-latex-extra <!nodoc>
 Build-Depends: cython3 (>= 0.29.2),
                debhelper-compat (= 11),
                dh-python,
@@ -13,18 +22,11 @@
                liblapack-dev [!arm !m68k],
                python3-all-dbg,
                python3-all-dev,
-               python3-doc,
-               python3-ipython,
-               python-matplotlib-doc,
-               python3-pytest,
-               python-scipy-doc,
-               python3-scipy,
+               python3-pytest <!nocheck>,
+               python3-scipy <!nocheck>,
                python3-setuptools,
-               python3-sphinx,
-               python3-tz,
-               texlive-latex-base,
-               texlive-latex-extra,
-Standards-Version: 4.4.1
+               python3-tz <!nocheck>
+Standards-Version: 4.5.0
 Vcs-Git: https://salsa.debian.org/python-team/modules/numpy.git
 Vcs-Browser: https://salsa.debian.org/python-team/modules/numpy
 Homepage: http://www.numpy.org/
@@ -38,7 +40,8 @@
           python3-dev,
           python3-pytest,
           python3-numpy-dbg
-Provides: python3-f2py,
+Provides: dh-sequence-numpy3,
+          python3-f2py,
           python3-numpy-dev,
           ${numpy3:Provides},
           ${python3:Provides}
@@ -86,6 +89,7 @@
 Section: doc
 Architecture: all
 Multi-Arch: foreign
+Build-Profiles: <!nodoc>
 Description: NumPy documentation
  Numpy contains a powerful N-dimensional array object, sophisticated
  (broadcasting) functions, tools for integrating C/C++ and Fortran

## numpy 1.19.5

=== doc/Makefile ===
--- 
+++ 
@@ -14,6 +14,10 @@
 SPHINXOPTS    ?=
 SPHINXBUILD   ?= LANG=C sphinx-build
 PAPER         ?=
+# For merging a documentation archive into a git checkout of numpy/doc
+# Turn a tag like v1.18.0 into 1.18
+# Use sed -n -e 's/patttern/match/p' to return a blank value if no match
+TAG ?= $(shell git describe --tag | sed -n -e's,v\([1-9]\.[0-9]*\)\.[0-9].*,\1,p')
 
 FILES=
 
@@ -24,7 +28,8 @@
   $(SPHINXOPTS) source
 
 .PHONY: help clean html web pickle htmlhelp latex changes linkcheck \
-        dist dist-build gitwash-update version-check html-build latex-build
+		dist dist-build gitwash-update version-check html-build latex-build \
+		merge-doc
 
 #------------------------------------------------------------------------------
 
@@ -40,6 +45,7 @@
 	@echo "  dist PYVER=... to make a distribution-ready tree"
 	@echo "  gitwash-update GITWASH=path/to/gitwash  update gitwash developer docs"
 	@echo "  upload USERNAME=... RELEASE=... to upload built docs to docs.scipy.org"
+	@echo "  merge-doc TAG=... to clone numpy/doc and archive documentation into it"
 
 clean:
 	-rm -rf build/* 
@@ -92,14 +98,16 @@
 endif
 
 
-dist:
+dist: build/dist.tar.gz
+
+build/dist.tar.gz:
 	make $(DIST_VARS) real-dist
 
-real-dist: dist-build html-build html-scipyorg
+real-dist: dist-build html-build
 	test -d build/latex || make latex-build
 	make -C build/latex all-pdf
 	-rm -rf build/dist
-	cp -r build/html-scipyorg build/dist
+	cp -r build/html build/dist
 	cd build/html && zip -9r ../dist/numpy-html.zip .
 	cp build/latex/numpy-ref.pdf build/dist
 	cp build/latex/numpy-user.pdf build/dist
@@ -113,7 +121,7 @@
 	install -d $(subst :, ,$(INSTALL_PPH))
 	$(PYTHON) `which easy_install` --prefix=$(INSTALL_DIR) ../dist/*.egg
 
-upload:
+upload: build/dist.tar.gz
 	# SSH must be correctly configured for this to work.
 	# Assumes that ``make dist`` was already run
 	# Example usage: ``make upload USERNAME=rgommers RELEASE=1.10.1``
@@ -130,6 +138,32 @@
 	ssh $(USERNAME)@docs.scipy.org rm $(UPLOAD_DIR)/dist.tar.gz
 	ssh $(USERNAME)@docs.scipy.org ln -snf numpy-$(RELEASE) /srv/docs_scipy_org/doc/numpy
 
+
+merge-doc: build/dist.tar.gz
+ifeq "$(TAG)" ""
+	echo tag "$(TAG)" not of the form 1.18;
+	exit 1;
+endif
+	@# Only clone if the directory does not exist
+	@if ! test -d build/merge; then \
+		git clone https://github.com/numpy/doc build/merge; \
+	fi;
+	@# Remove any old content and copy in the new, add it to git
+	-rm -rf build/merge/$(TAG)/*
+	-mkdir -p build/merge/$(TAG)
+	@# -C changes working directory
+	tar -C build/merge/$(TAG) -xf build/dist.tar.gz
+	git -C build/merge add $(TAG)
+	@# For now, the user must do this. If it is onerous, automate it and change
+	@# the instructions in doc/HOWTO_RELEASE.rst.txt
+	@echo " "
+	@echo New documentation archive added to ./build/merge.
+	@echo Now add/modify the appropriate section after
+	@echo "    <!-- insert here -->"
+	@echo in build/merge/index.html,
+	@echo then \"git commit\", \"git push\"
+	
+
 #------------------------------------------------------------------------------
 # Basic Sphinx generation rules for different formats
 #------------------------------------------------------------------------------
@@ -183,7 +217,7 @@
 	mkdir -p build/latex build/doctrees
 	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) build/latex $(FILES)
 	$(PYTHON) postprocess.py tex build/latex/*.tex
-	perl -pi -e 's/\t(latex.*|pdflatex) (.*)/\t-$$1 -interaction batchmode $$2/' build/latex/Makefile
+	perl -pi -e 's/LATEXOPTS =/LATEXOPTS ?= --halt-on-error/' build/latex/Makefile
 	@echo
 	@echo "Build finished; the LaTeX files are in build/latex."
 	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \

=== doc/cdoc/Makefile ===
all: build

build:
	doxygen

clean:
	rm -rf build

.PHONY: all build clean

=== debian/changelog ===
numpy (1:1.19.5-1) unstable; urgency=medium

  * New upstream release
  * Use the new Debian Python Team contact name and address
  * debian/control
    - bump Standards-Version to 4.5.1 (no changes needed)
    - run wrap-and-sort
  * debian/copyright
    - extend packaging copyright years

 -- Sandro Tosi <morph@debian.org>  Wed, 13 Jan 2021 01:25:24 -0500

numpy (1:1.19.4-1) unstable; urgency=medium

  * New upstream release

 -- Sandro Tosi <morph@debian.org>  Mon, 02 Nov 2020 23:30:38 -0500

numpy (1:1.19.3-1) unstable; urgency=medium

  * New upstream release

 -- Sandro Tosi <morph@debian.org>  Wed, 28 Oct 2020 22:59:46 -0400

numpy (1:1.19.2-2) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/control: Update Vcs-* fields with new Debian Python Team Salsa
    layout.

  [ Sandro Tosi ]
  * debian/tests/control
    - add hypothesis to some autopkgtests

 -- Sandro Tosi <morph@debian.org>  Fri, 25 Sep 2020 01:48:22 -0400

numpy (1:1.19.2-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches
  * debian/patches/sphinx_no_dashW.patch
    - remove -W option from sphinx-build, until upstream supports sphinx 3

 -- Sandro Tosi <morph@debian.org>  Wed, 16 Sep 2020 01:14:11 -0400

numpy (1:1.19.1-1) unstable; urgency=medium

  * New upstream release
  * debian/control
    - update versione b-d on hypothesis to >= 5.19.1
    - bump b-d on cython3 to >= 0.29.21

 -- Sandro Tosi <morph@debian.org>  Wed, 22 Jul 2020 20:59:57 -0400

numpy (1:1.19.0-1) unstable; urgency=medium

  * New upstream release
  * upload to unstable

 -- Sandro Tosi <morph@debian.org>  Sun, 21 Jun 2020 21:02:50 -0400

numpy (1:1.19.0~rc2-2) experimental; urgency=medium

  * debian/patches/debian_skip_tests.patch
    - skip test_full_reimport

 -- Sandro Tosi <morph@debian.org>  Sat, 06 Jun 2020 20:31:14 -0400

numpy (1:1.19.0~rc2-1) experimental; urgency=medium

  * New upstream release candidate
  * debian/control
    - update b-d on hypothesis to be versioned >= 5.12.0

 -- Sandro Tosi <morph@debian.org>  Wed, 03 Jun 2020 21:11:56 -0400

numpy (1:1.19.0~rc1-1) experimental; urgency=medium

  * New upstream release candidate
  * debian/control
    - add hypothesis to b-d, needed by tests
    - add skimage, imageio -doc pkgs to b-d, needed by doc intersphinx objects
  * debian/patches/*
    - refresh/update patches
  * debian/copyright
    - update upstream copyright notice

 -- Sandro Tosi <morph@debian.org>  Mon, 18 May 2020 18:48:37 -0400

=== debian/control ===
--- 
+++ 
@@ -1,19 +1,20 @@
 Source: numpy
 Section: python
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Sandro Tosi <morph@debian.org>
-Uploaders: Debian Python Modules Team <python-modules-team@lists.alioth.debian.org>
-Build-Depends-Indep: python-matplotlib-doc <!nodoc>,
+Maintainer: Sandro Tosi <morph@debian.org>
+Uploaders: Debian Python Team <team+python@tracker.debian.org>,
+Build-Depends-Indep: python-imageio-doc <!nodoc>,
+                     python-matplotlib-doc <!nodoc>,
                      python-scipy-doc <!nodoc>,
+                     python-skimage-doc <!nodoc>,
                      python3-doc <!nodoc>,
                      python3-ipython <!nodoc>,
                      python3-matplotlib <!nodoc>,
                      python3-scipy <!nodoc>,
                      python3-sphinx (>= 2) <!nodoc>,
                      texlive-latex-base <!nodoc>,
-                     texlive-latex-extra <!nodoc>
-Build-Depends: cython3 (>= 0.29.2),
+                     texlive-latex-extra <!nodoc>,
+Build-Depends: cython3 (>= 0.29.21),
                debhelper-compat (= 11),
                dh-python,
                dvisvgm,
@@ -22,29 +23,33 @@
                liblapack-dev [!arm !m68k],
                python3-all-dbg,
                python3-all-dev,
+               python3-hypothesis (>= 5.19.1) <!nocheck>,
                python3-pytest <!nocheck>,
                python3-scipy <!nocheck>,
                python3-setuptools,
-               python3-tz <!nocheck>
-Standards-Version: 4.5.0
-Vcs-Git: https://salsa.debian.org/python-team/modules/numpy.git
-Vcs-Browser: https://salsa.debian.org/python-team/modules/numpy
+               python3-tz <!nocheck>,
+Standards-Version: 4.5.1
+Vcs-Git: https://salsa.debian.org/python-team/packages/numpy.git
+Vcs-Browser: https://salsa.debian.org/python-team/packages/numpy
 Homepage: http://www.numpy.org/
 
 Package: python3-numpy
 Architecture: any
-Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}, python3-pkg-resources
+Depends: python3-pkg-resources,
+         ${misc:Depends},
+         ${python3:Depends},
+         ${shlibs:Depends},
 Suggests: gcc (>= 4:4.6.1-5),
           gfortran,
           python-numpy-doc,
           python3-dev,
+          python3-numpy-dbg,
           python3-pytest,
-          python3-numpy-dbg
 Provides: dh-sequence-numpy3,
           python3-f2py,
           python3-numpy-dev,
           ${numpy3:Provides},
-          ${python3:Provides}
+          ${python3:Provides},
 Breaks: python3-aplpy (<< 2.0~rc2-1),
         python3-astropy (<< 3.1-1),
         python3-ccdproc (<< 1.3.0-5),
@@ -71,7 +76,7 @@
 Depends: python3-dbg,
          python3-numpy (= ${binary:Version}),
          ${misc:Depends},
-         ${shlibs:Depends}
+         ${shlibs:Depends},
 Description: Fast array facility to the Python 3 language (debug extension)
  Numpy contains a powerful N-dimensional array object, sophisticated
  (broadcasting) functions, tools for integrating C/C++ and Fortran
@@ -85,7 +90,8 @@
  This package contains the extension built for the Python 3 debug interpreter.
 
 Package: python-numpy-doc
-Depends: ${misc:Depends}, ${sphinxdoc:Depends}
+Depends: ${misc:Depends},
+         ${sphinxdoc:Depends},
 Section: doc
 Architecture: all
 Multi-Arch: foreign

=== debian/rules ===
--- 
+++ 
@@ -128,6 +128,7 @@
 	# source directory, so we need to mess with the import order so to
 	# select the code in the installation path
 ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
+	echo "TEST STARTED" `date`
 	set -e; for v in $(PY3VERS) ; do \
 		cd debian ; \
 		echo "-- running tests for "$$v" plain --" ; \
@@ -136,4 +137,5 @@
 		python$$v-dbg -c "import sys ; sys.path.insert(0, './tmp/usr/lib/python3/dist-packages/') ; import numpy; numpy.test(verbose=5)" ; \
 		cd .. ; \
 	done
+	echo "TEST ENDED" `date`
 endif

=== debian/tests/control ===
Tests: python3
Depends: build-essential, python3-numpy, python3-all, python3-pytest, python3-tz, python3-hypothesis

#needs root for update-alternatives
Tests: openblas
Restrictions: needs-root
Depends: python3-numpy, python3-all, python3-pytest, python3-tz, libopenblas-base, dpkg-dev, gcc, python3-hypothesis

#needs root for update-alternatives
Tests: atlas
Restrictions: needs-root
Depends: python3-numpy, python3-all, python3-pytest, python3-tz, libatlas3-base, dpkg-dev, gcc, python3-hypothesis

Tests: f2py
Depends: build-essential, gfortran, python3-numpy, python3-numpy-dbg, python3-all, python3-all-dbg, python3-all-dev

Tests: distutils
Restrictions: allow-stderr
Depends: build-essential, libfftw3-dev, python3-numpy, python3-distutils

Tests: capi
Depends: build-essential, python3-all-dev, python3-all-dbg, python3-numpy, python3-numpy-dbg

=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/ \
https://pypi.debian.net/numpy/numpy-(.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
#opts="pgpmode=none" \
#    https://pypi.python.org/pypi/numpy/ \
#    https://pypi.python.org/packages/.*/.*/.*/numpy-([\d\.]+).zip#.*
